@use '../../stylesheets/core';

/**
 * $name:  The variant name
 * $color: The color name
 *
 * The color should have corresponding CSS variables:
 *    --state-color-<color>
 *    --state-color-<color>-alt
 *    --state-color-<color>--hover
 *    --state-color-<color>--active
 */
@mixin variant($name, $color) {
  &.rui-button--#{$name} {
    background-color: var(--state-color-#{$color});
    color: var(--state-color-#{$color}-alt);

    &:hover {
      background-color: var(--state-color-#{$color}--hover);
    }

    &:active,
    &.rui-button--active {
      background-color: var(--state-color-#{$color}--active);
    }

    &:disabled,
    &.rui-button--disabled {
      background-color: var(--state-color-#{$color});
      color: var(--state-color-#{$color}-alt);

      // Don't change background
      &:hover {
        background-color: var(--state-color-#{$color});
      }
    }
  }

  &.rui-button--text--#{$name} { // stylelint-disable-line no-duplicate-selectors
    color: var(--state-color-#{$color});
  }

  &.rui-button--#{$name}-text { // stylelint-disable-line no-duplicate-selectors
    color: var(--state-color-#{$color});
  }
}

%button {
  display: inline-flex;
  height: 1.5625rem;
  align-items: center;
  padding: var(--spacer-tiny) var(--spacer-small);
  border: none;
  background-color: var(--button-background);
  color: var(--button-color);
  cursor: pointer;
  font-size: var(--font-size-base);
  font-variant: small-caps;
  gap: var(--spacer-small);
  line-height: 1em;
  text-decoration: none;
  white-space: nowrap;

  &:visited {
    color: var(--button-color);
  }

  &:hover {
    background-color: var(--button-background--hover);
    color: var(--button-color);
  }

  &:active,
  &.rui-button--active {
    background-color: var(--button-background--active);
    color: var(--button-color);
  }

  &:disabled,
  &.rui-button--disabled {
    background-color: var(--button-background);
    background-image:
      linear-gradient(
          135deg,
          transparent,
          transparent 5px,
          var(--button-color--disabled) 5px,
          var(--button-color--disabled) 6px,
          transparent 6px,
          transparent 100%
      );
    background-size: 8px 8px;
    color: var(--button-color);
    cursor: not-allowed;

    // Don't change background
    &:hover {
      background-color: var(--button-background);
    }
  }
}

.rui-button {
  @extend %button;

  // Transparent background, colored text
  &--text {
    background-color: transparent;

    &:disabled {
      background-color: transparent;
    }
  }

  // Bigger button
  &--large {
    height: 2.1875rem;
    padding: var(--spacer-default);
    font-size: var(--font-size-medium);
  }

  // Smaller button
  &--small {
    height: 1.25rem;
    font-size: var(--font-size-small);

    // Reduce icon size
    svg {
      height: var(--font-size-small);
    }
  }

  // Wide variants
  &--block {
    width: 100%;
    justify-content: center;
  }

  // Use this variant for placeholders
  &--no-action {
    pointer-events: none;
  }

  &--no-text-on-small {
    @include core.respond-to('small') {
      .rui-button__text {
        @include core.sr-only();
      }
    }
  }

  &--waiting {
    cursor: wait;

    &.rui-button--disabled {
      cursor: wait;
    }
  }

  @include variant('destructive', 'red');
  @include variant('creative', 'blue');
  @include variant('helping', 'blue');
  @include variant('recording', 'green');
  @include variant('canceling', 'orange');
  @include variant('dim', 'mute');
}

button,
input[type='submit'],
input[type='reset'],
input[type='button'] {
  @extend %button;
}
